;===============================================================
;  MSX STAR SOLDIER
;
;	ボス パラメータセット
;
;===============================================================
org	#4e63

proc
		; ここで敵objの設定をすると、
		; でかいボスのとき画面からはみ出して
		; いきなり下部に出現してしまうのでやめる
		ld		a,(#cde4)
		and		3
		ld		a,5			; ATTACK STAR BRAIN
		jr		nz,_set
		dec		a			; ATTACK BIG STAR BRAIN
	_set:
		pop		hl
		jp		#417b
endp


; すでに不要になったボス登場シーンの画面更新処理の箇所でパラメータをセット
boss_set_param:
val_443a_in_rom_019e	equ	boss_set_param
proc
		ld		a,(#ce7e)
		cp		#f8 &(boss_put_start_y-16)
		ret		nz

		ld		a,(#cde4)

		ld		hl,#0012		; 通常ボスブラグ,エスケープカウンタ
		ld		ixl,#80+7		; 専有するオブジェクトの先頭の番号+ix用の#80
		ld		bc,#05fd		; キャラ数,砲台の色
		ld		de,_param_ll
		and		7
		jr		z,_size_found

		ld		l,10
		ld		de,_param_big
		and		3
		jr		z,_size_found

		ld		hl,#0104
		ld		ixl,#80+11
		ld		b,1
		ld		de,_param_normal2
		rrca
		jr		nc,_size_found
		ld		a,(#cf28)
		or		a
		jr		nz,_size_found
		ld		de,_param_normal

	_size_found:
		ld		a,(#cf0a)	; 始動方向によってエスケープ時間が変わる
		dec		a
		jr		z,_set
		dec		l
	_set:
		ld		(#cf0c),hl	; エスケープ,通常ボスフラグ

		ld		a,(#cf28)
		or		a
		ld		a,#4f		; カプセルの色
		jr		z,_end_uracolor
		ld		c,#f2		; 裏面の目玉の色
		ld		a,#bf		; 裏面のカプセルの色
	_end_uracolor:
		ld		(#c1c8),a	; カプセルの色

	_lp:
		ld		ixh,#c0
		ld		(ix-128),#23	;#c000
		ld		(ix-104),#f0	;#c018
		ld		(ix -80),#f0	;#c030
		ld		(ix  -8),0		;#c078
		ld		(ix+ 16),#10	;#c090
		ld		(ix+ 88),0		;#c0d8
		ld		(ix+112),#08	;#c0f0
		ld		(ix +40),0		;#c0a8
		ld		a,(de)
		inc		de
		ld		(ix +64),a		;#c0c0	; xオフセット
		ld		ixh,#c1
		ld		a,(de)
		inc		de
		ld		(ix -96),a		;#c120	; yオフセット

		ld		(ix -72),#08	;#c138
		ld		(ix +24),#ff	;#c198
		ld		(ix +48),0		;#c1b0
		ld		(ix +72),c		;#c1c8	; 色=fd,f2
		inc		ix
		djnz	_lp	
	
		dec		ix
		ld		(ix +72),#9b	;#c1c8	; 色
		ld		ixh,#c0
		ld		(ix-128),#22	;#c000
		;ld		(ix +16),#10	;#c090
		ld		(ix +88),#01	;#c0d8
		ld		(ix+112),0		;#c0f0

		; ボスの子分スプライト書き換え
		ld		ix,boss_sprite_load
		ld		iyl,bank_boss_sprite
		jp		call_bank_boss_sprite

	_param_ll:
		db		#b8,   #8c-3,  #38, #8c-3,  #d8, #bc-3,  #18, #bc-3
		db		#f4+8, #8c-2
	_param_big:
		db		#c4,   #9c,    #24, #9c,    #dc, #bc,    #0c, #bc
		db		#f4+4, #9c-2
	_param_normal:
		db		#f4+4, #ac+5
	_param_normal2:
		db		#f4+4, #ac+5+8+1

endp
