;===============================================================
;  MSX STAR SOLDIER
;
;	ボス表示
;
;===============================================================
;	ボス待ち中のBG更新　→　何もしない(SAT更新処理と同じタイミングで更新)
val_cd_in_rom_015a		equ	#21
;val_cd_in_rom_019d		equ	#21					; ボス設定処理に振り分けた

; BOSS y座標 初期値
val_b8_in_rom_016f		equ	#b8-1+8 +4			; ボス初期y基準位置
; ボス登場待ちカウンタ各種位置
val_88_in_rom_014d		equ	#88-1+8 +4			; ボス登場待ちカウンタ、ボス登場位置
boss_put_start_y		equ	val_88_in_rom_014d

; BOSS 砲台位置8ドット単位修正をやめる
val_28_in_rom_479f		equ	#00
;val_f8_in_rom_47a4		equ	#ff			; xは補正有効
val_f8_in_rom_47b3		equ	#ff



; ネーム配置関係
bossL_pn		equ	#e000;#af25
bossL_w			equ	21
bossL_h			equ	13
bossL_n			equ	12
bossL_de_ofs	equ	#20*2

bossS_pn		equ	#e000+bossL_h*bossL_w;#b036
bossS_w			equ	15
bossS_h			equ	7	+1
bossS_n			equ	16
bossS_de_ofs	equ	1

bossLL_pn		equ	#e000;#af25
bossLL_w		equ	25
bossLL_h		equ	16
bossLL_n		equ	12
bossLL_de_ofs	equ	#20*4




;===============================
;
;===============================
on_pre_boss_scroll:
		call	update_cur_bg_y
		jp		boss_put_bg_1line
val_5c03_in_rom_0158	equ	on_pre_boss_scroll
val_5c03_in_rom_0193	equ	on_pre_boss_scroll


;===============================
; boss bg一行書き込み準備
;===============================
boss_put_setup:
proc
		; 現在のスクロール基準点を記憶
		ld		hl,back_page
		ld		l,(hl)
		inc		l
		ld		a,(hl)
		add		a,23
		ld		(boss_scr_y_org),a

		; ボス絵のソースをセット
		ld		a,(#cde4)
		and		7
		ld		hl,bossLL_pn + bossLL_w *(bossLL_h-1)
		jr		z,_set
		and		3
		ld		hl,bossL_pn + bossL_w *(bossL_h-1)
		jr		z,_set
		ld		hl,bossS_pn + bossS_w *(bossS_h-1)
	_set:
		ld		(cur_boss_src),hl

		; ボスパレットアニメ設定
		ld		hl,cfg_palette_tbl
		call	update_palette_hl
		call	palette_anime_set_boss
		ret
endp
val_41be_in_rom_0182	equ	boss_put_setup
;004181: cd be 41     CALL 0x41be	; BOSS 仮想PCGを並べる


;===============================
; boss bg一行書き込み
;===============================
boss_put_bg_1line:
		call	star_put_boss_1line

		ld		a,(0xce7e)
		cp		boss_put_start_y
		jp		nc, boss_put_bg_1line_put
proc
	;ボスを配置
		ld		hl,(cur_boss_src)
		ld		a,(#cde4)
		and		7
		jp		z,_llarge
		and		3
		jp		z,_large
	_small:
		ld		de,#c300 + bossS_de_ofs
		ld		ix,+( bossS_w<<8 )|( 32+1-bossS_w )
		ld		iyl,bossS_n
		ld		a,bossS_pn-bossS_w
		jp		_put
	_large:
		ld		de,#c300 + bossL_de_ofs
		ld		ix,+( bossL_w<<8 )|( 32+1-bossL_w )
		ld		iyl,bossL_n
		ld		a,bossL_pn-bossL_w
		jp		_put
	_llarge:
		ld		de,#c300 + bossLL_de_ofs
		ld		ix,+( bossLL_w<<8 )|( 32+1-bossLL_w )
		ld		iyl,bossLL_n
		ld		a,bossLL_pn-bossLL_w

	_put:
		cp		l
		jr		z,boss_put_bg_1line_put

	_lpY:
		push	hl
		ld		b,ixh
	_lp:
		ld		a,(hl)
		or		a
		jr		z,_nx
		ld		(de),a
	_nx:
		inc		hl
		inc		de
		djnz	_lp

		ld		a,e
		add		a,ixl
		ld		e,a
		jr		nc,_sk
		inc		d
	_sk:
		dec		iyl
		pop		hl
		jr		nz,_lpY

	;_skipsrc:
		ld		a,l
		sub		ixh
		ld		l,a
		jr		nc,_updtsrc
		dec		h
	_updtsrc:
		ld		(cur_boss_src),hl
endp
boss_put_bg_1line_put:
proc
	; vramに転送
		ld		hl,#c300
		ld		de,(cur_bg_adr)
		ld		ixl,#10
	_lp_v:
		call	set_vram_adr_de
		ld		b,#20
		otir
		ld		a,d
		add		a,4
		ld		d,a
		dec		ixl
		jp		nz,_lp_v

		; 次回転送先移動
		jp		update_cur_bg_adr
endp



;===============================
;	ボス撃破時追加処理
;===============================
on_boss_break_while_wait:		; 覆いのスプライトを外すので、この時点で絵を書き換える必要がある
val_44bb_in_rom_0185	equ		on_boss_break_while_wait
		call	#44bb			; 本来の処理
		ld		a,(#c000+11)
		sub		#28
		ret		nz
		dec		a		;a=0xff
on_boss_break:
proc
		ld		(#cf11),a		; 本来の処理

		call	palette_anime_set_boss_break

		; 脳みそ表示
		ld		a,(#cf0d)
		or		a
		ret		z				; 大ボスはなし
		ld		a,(#cf28)
		or		a
		jr		nz,_brain		; 裏面はON
		ld		a,(#cde4)
		rrca
		ret		c				; 奇数ステージはなし

	_brain:
		; PNTベースアドレス
		ld		hl,back_page
		ld		l,(hl)
		inc		l
		inc		l
		ld		a,(hl)	; back pnt vdp val
		ld		c,a		; pnt x ofs
		add		a,a
		add		a,a
		ld		d,a		; back pnt h
		ld		e,0

		; PNTオフセットアドレス計算
		ld		hl,(cur_bg_adr)
		; pnt x ofs
		ld		a,l
		add		a,c
		sub		8+1
		ld		l,a
		; ボス登場中の原点差分
		ld		a,(#ce7e)
		or		a
		jr		z,_not_scr
		ld		b,a
		ld		a,(#cf18)		; スクロール差分
		and		4
		add		a,a
		neg
		add		a,b
	_not_scr:
		add		a,13*8+4
		and		#f8
		ld		b,0
		rla
		rl		b
		rla
		rl		b
		inc		b
		ld		c,a
		sbc		hl,bc
		; オフセット化
		ld		a,h
		and		#03
		ld		h,a

		; 書き込み
		add		hl,de
		ex		de,hl

		call	set_vram_adr_de
		ld		l,#b0
		ld		b,3
		call	_wrt_lp

		ld		l,#b3
		ld		bc,#051f
		call	_wrt

		ld		l,#b3
		ld		bc,#0520
		call	_wrt

		ld		l,#b8
		ld		bc,#0321
	_wrt:
		ld		a,e
		add		a,c
		ld		e,a
		jr		nc,_sk
		inc		d
	_sk:
		ld		a,d
		and		3
		add		a,h
		ld		d,a
		call	set_vram_adr_de
	_wrt_lp:
		out		(c),l
		inc		l
		djnz	_wrt_lp
		ret
endp


;===============================
;	PCG解凍
;===============================
DecompressLZSA_PCGCOLPN_BOSS_title:
		xor		a
		ld		(#cf28),a
DecompressLZSA_PCGCOLPN_BOSS:
proc
		ld		(#ce7f),hl
		ld		a,(#cf28)	; 裏面？
		or		a
		ld		a,(#cde4)
		ld		iyl,bank_boss_dat2
		jr		nz,_ura
		ld		hl,pcgcolpn_bsb_nes_lzsa
		and		7
		jr		z,_decode
		and		3
		jr		z,_decode_org
		rrca
		jr		c,_decode_org
		ld		hl,pcgcolpn_sb_nes_lzsa
		jr		_decode
	_decode_org:
		ld		hl,pcgcolpn_boss_lzsa
		ld		iyl,bank_boss_dat
	_decode:
		ld		ix,DecompressLZSA_to_d600
		jp		call_bank_boss_dat
	_ura:
		ld		hl,pcgcolpn_mzb_nes_lzsa
		and		7
		jr		z,_decode
		ld		hl,pcgcolpn_mzb_lzsa
		and		3
		jr		z,_decode
		ld		hl,pcgcolpn_zb_lzsa
		jr		_decode
endp
val_22_in_rom_00163		equ	#cd
val_ce7f_in_rom_00164	equ DecompressLZSA_PCGCOLPN_BOSS
val_22_in_rom_019dc		equ	#cd
val_ce7f_in_rom_019dd	equ DecompressLZSA_PCGCOLPN_BOSS_title
