;==============================================================================
;
; MSX スターソルジャー
;
;==============================================================================


;================================================================
;	カラーパレット編集モード
;================================================================
color_palette_editor:
PROC
		call	editor_setup
		call	setup_sample_pcg
		call	color_palette_editor_setup

		jp		_key_off_wait

	_main_loop:
		call	color_palette_editor_update_disp
		call	editor_get_key
		jr		z,_main_loop
		cp		#1b
		jr		z, _exit

		ld		hl,cfg_palette_cursor_pos
		cp		#1e
		jr		z,_up
		cp		#1f
		jr		z,_down
		cp		#1c
		jr		z,_right
		cp		#1d
		jr		z,_left
		cp		#20
		jr		z,_space
		sub		'0'
		jr		c,_main_loop
		cp		10
		jr		c,_number
		sub		17
		jr		c,_main_loop
		add		a,10
		cp		16
		jr		c,_number
		jr		_main_loop

	_exit:
		call	release_sample_pcg
		jp		editor_close

	_left:
		ld		b,-1
		jr		_lr
	_right:
		ld		b,1
	_lr:
		ld		a,(hl)
		add		a,b
		and		#f
		ld		b,a
		ld		a,(hl)
		and		#f0
		or		b
		ld		(hl),a
		jr		_key_off_wait

	_up:
		ld		b,#f0
		jr		_ud
	_down:
		ld		b,#10
	_ud:
		ld		a,(hl)
		add		a,b
		and		#70
		ld		b,a
		ld		a,(hl)
		and		#f
		or		b
		ld		(hl),a
		jr		_key_off_wait

	_space:
		ld		hl,cfg_palette_cursor_pos
		ld		a,(hl)
		cp		#40
		jr		nc,_space_stage
		cp		#10
		jr		nc,_space_pallet
	;_space_pallet_set:
		ld		hl,cfg_palette_set
		ld		a,(hl)
		inc		a
		and		#f
		ld		(hl),a
		jr		_key_off_wait
	_space_pallet:
		call	_get_palette_adr_from_cursor_pos
		ld		c,#77
		call	_inc_value_at_hl
		jr		_key_off_wait
	_space_stage:
		call	_get_st2pl_adr_from_cursor_pos
		ld		c,#ff
		call	_inc_value_at_hl
	_space_stage_end:
		ld		a,(cfg_palette_cursor_pos)
		call	_switch_palette_set
		jr		_key_off_wait

	_number:
		and		#f
		ld		c,a
		ld		hl,cfg_palette_cursor_pos
		ld		a,(hl)
		cp		#40
		jr		nc,_number_stage
		cp		#10
		jr		nc,_number_pallet
	;_number_pallet_set:
		ld		a,c
		ld		(cfg_palette_set),a
		jr		_key_off_wait
	_number_pallet:
		ld		a,c
		and		7
		ld		c,a
		ld		a,(hl)
		call	_get_palette_adr_from_cursor_pos
		ld		a,c
		call	_set_value_at_hl
		jr		_key_off_wait
	_number_stage:
		call	_get_st2pl_adr_from_cursor_pos
		ld		a,c
		call	_set_value_at_hl
		jr		_space_stage_end


	_key_off_wait:
		ld		a,(cfg_palette_cursor_pos)
		cp		#40
		;push	af
		call	c,_put_color_sample
		;pop		af
		;call	nc,_switch_palette_set
		call	color_palette_editor_get_cur_palette_tbl
		ld		ix,update_palette_hl
		ld		iyl,1
		call	call_bank_6000
		call	editor_key_off_wait
		jp		_main_loop



	_set_value_at_hl:
		jr		nz,_set_value_at_hl_low
		rlca
		rlca
		rlca
		rlca
		and		#f0
		ld		b,a
		ld		a,(hl)
		and		#0f
		or		b
		ld		(hl),a
		ret
	_set_value_at_hl_low:
		and		#f
		ld		b,a
		ld		a,(hl)
		and		#f0
		or		b
		ld		(hl),a
		ret

	_inc_value_at_hl:
		ld		a,(hl)
		jr		nz,_inc_value_at_hl_low
		add		a,#10
		and		c
		ld		(hl),a
		ret
	_inc_value_at_hl_low:
		and		#f0
		ld		b,a
		ld		a,(hl)
		inc		a
		and		c
		and		#f
		or		b
		ld		(hl),a
		ret

	_get_palette_adr_from_cursor_pos:
		sub		#10
		ld		b,a
		call	color_palette_editor_get_cur_palette_tbl
		ld		a,b
		and		#f
		add		a,a
		add		a,l
		ld		l,a
		ld		a,b
		bit		4,b
		jr		z,_isnot_g
		inc		l
	_isnot_g:
		and		#30
		ret

	_get_st2pl_adr_from_cursor_pos:
		sub		#40
		ld		h,a
		rrca
		and		#10
		add		a,cfg_st2pal_tbl
		ld		l,a
		ld		a,h
		and		#f
		or		l
		ld		l,a
		ld		a,h
		ld		h,cfg_st2pal_tbl>>8
		and		#10
		ret

	_switch_palette_set:
		call	_get_st2pl_adr_from_cursor_pos
		ld		a,(hl)
		jr		nz,_switch_palette_set_end
		rlca
		rlca
		rlca
		rlca
	_switch_palette_set_end:
		and		#f
		ld		(cfg_palette_set),a
		ret

	_put_color_sample:
		push	af			; cfg_palette_cursor_pos
		and		#f
		add		a,#20
		ld		l,a
		ld		h,3
		ld		de,#38b9
	_lpH:
		call	set_vram_adr_de
		ld		b,3
	_lpB:
		out		(c),l
		djnz	_lpB
		ld		a,e
		add		a,#20
		ld		e,a
		dec		h
		jr		nz,_lpH
		pop		af
		ret
endp


color_palette_editor_get_cur_palette_tbl:
		ld		a,(cfg_palette_set)
		ld		l,0
		or		a
		rra
		rr		l
		rra
		rr		l
		rra
		rr		l
		add		a,cfg_palette_tbl>>8
		ld		h,a
		ret

;==============================================================================
;  0123456789abcdef0123456789abcdef|y
;21                                |
;42      COLOR PALETTE  SET 0      |0
;63       0123456789ABCDEF         |
;84       ================         |
;a5     R 0217351263216365  ===    |1
;c6     G 5345143513253252  ===    |2
;e7     B 2354132413252135  ===    |3
;08                                |
;29          PALETTE ASSIGN        |
;4a    STAGE 123456789ABCDEFG      |
;6b    MSX A 0000000000000000      |4
;8c        B 0000000000000000      |5
;ad    NES A 0000000000000000      |6
;ce        B 0000000000000000      |7
;ef                                |
;==============================================================================
color_palette_editor_setup:
proc
		; PCGをベタ並べ
		ld		de,#3a00
		call	set_vram_adr_de
		xor		a
		ld		b,a
	_lp256:
		out		(c),a
		inc		a
		djnz	_lp256

		; "COLOR PALETTE SET"
		ld		de,6+(1*32)
		ld		hl,tx_paled_lb0
		call	editor_put_str

		; color code
		ld		de,#3867
		ld		a,'0'
		ld		b,10
		call	_put_chr_seq
		ld		a,'A'
		ld		b,6
		call	_put_chr_seq_lp

		; color sample
		ld		de,#3887
		ld		a,#20
		ld		b,#10
		call	_put_chr_seq

		; RGB
		ld		hl,#38a5
		ld		a,"R"
		call	#004d
		ld		hl,#38c5
		ld		a,"G"
		call	#004d
		ld		hl,#38e5
		ld		a,"B"
		call	#004d


		;PALETTE ASSIGN
		ld		de,6+(8*32)
		ld		hl,tx_paled_lb1
		call	editor_put_str

		;STAGE
		ld		de,4+(9*32)
		ld		hl,tx_paled_lb2
		call	editor_put_str
		; stage
		ld		a,'1'
		ld		b,9
		call	_put_chr_seq_lp
		ld		a,'A'
		ld		b,7
		call	_put_chr_seq_lp

		;MSX A
		ld		de,4+(10*32)
		ld		hl,tx_paled_lb3
		call	editor_put_str
		;MSX B
		ld		hl,#3988
		ld		a,"B"
		call	#004d
		;NES A
		ld		de,4+(12*32)
		ld		hl,tx_paled_lb4
		call	editor_put_str
		;NES B
		ld		hl,#39c8
		ld		a,"B"
		jp		#004d

	_put_chr_seq:
		push	af
		call	set_vram_adr_de
		pop		af
	_put_chr_seq_lp:
		out		(c),a
		inc		a
		djnz	_put_chr_seq_lp
		ret
endp

color_palette_editor_update_disp:
proc
		; 選択中セット
		ld		de,#3859
		call	set_vram_adr_de
		ld		a,(cfg_palette_set)
		call	_put_hex

		; パレット
		call	color_palette_editor_get_cur_palette_tbl

		push	hl
		ld		de,#38a7
		call	set_vram_adr_de
		ld		b,#10
	_lpR:
		ld		a,(hl)
		rrca
		rrca
		rrca
		rrca
		call	_put_hex
		inc		l
		inc		l
		djnz	_lpR
		pop		hl

		push	hl
		ld		de,#38c7
		inc		l
		call	_put_g_b
		pop		hl

		ld		de,#38e7
		call	_put_g_b

		; ステージ毎のパレット割付
		ld		hl,cfg_st2pal_tbl
		ld		de,#396a
		call	_put_st2palA
		ld		hl,cfg_st2pal_tbl
		ld		de,#398a
		call	_put_st2palB
		ld		hl,cfg_st2pal_tbl+16
		ld		de,#39aa
		call	_put_st2palA
		ld		hl,cfg_st2pal_tbl+16
		ld		de,#39ca
		call	_put_st2palB

		; カーソル
		ld		a,(cfg_palette_cursor_pos)
		cp		#40
		jr		nc,_cursor_stage
		cp		#10
		jr		nc,_cursor_pallet
	;_cursor_pallet_set:
		ld		de,#3859
		jr		_put_cursor
	_cursor_pallet:
		ld		de,#3887
		jr		_put_cursor_
	_cursor_stage:
		ld		de,#39ea
	_put_cursor_:
		ld		b,a
		and		#70
		add		a,a
		add		a,e
		ld		e,a
		ld		a,b
		and		#f
		add		a,e
		ld		e,a
	_put_cursor:
		call	set_vram_adr_de
		ld		a,'/'
		out		(c),a
		ret


	_put_g_b:
		call	set_vram_adr_de
		ld		b,#10
	_put_g_b_lp:
		ld		a,(hl)
		and		#7
		add		a,"0"
		out		(c),a
		inc		l
		inc		l
		djnz	_put_g_b_lp
		ret

	_put_st2palA:
		call	set_vram_adr_de
		ld		b,#10
	_put_st2palA_lp:
		ld		a,(hl)
		rrca
		rrca
		rrca
		rrca
		call	_put_hex
		inc		l
		djnz	_put_st2palA_lp
		ret

	_put_st2palB:
		call	set_vram_adr_de
		ld		b,#10
	_put_st2palB_lp:
		ld		a,(hl)
		call	_put_hex
		inc		l
		djnz	_put_st2palB_lp
		ret

	_put_hex:
		and		#f
		cp		10
		jr		c,_put_hex_out
		add		a,7
	_put_hex_out:
		add		a,'0'
		out		(c),a
		ret
endp


;==============================================================================
;	見本作成
;==============================================================================
setup_sample_pcg:
proc
		; 色見本
		ld		de,#2000+32*8
		call	_wrt
		ld		d,#29
	_wrt:
		call	set_vram_adr_de
		ld		d,#10
		xor		a
	_lp16:
		ld		b,8
	_lp8:
		out		(c),a
		djnz	_lp8
		add		a,#11
		dec		d
		jr		nz,_lp16

		; PCG見本
		ld		ix,#9010
		call	setup_pcg_sample_copy
		ld		ix,#f030
		jp		setup_pcg_sample_copy
ENDP


;	見本開放
release_sample_pcg:
proc
		; 色見本戻す
		ld		de,#2000+32*8
		call	_wrt
		ld		d,#29
	_wrt:
		call	set_vram_adr_de
		ld		d,#10
		ld		a,#f0
	_lp16:
		ld		b,8
	_lp8:
		out		(c),a
		djnz	_lp8
		dec		d
		jr		nz,_lp16
		ld		d,#30

		; PCG見本戻す
		ld		ix,#0010
		call	setup_pcg_sample_copy
		ld		ix,#2030
		jp		setup_pcg_sample_copy
ENDP


; VRAM間コピー
setup_pcg_sample_copy:
proc
		ld		e,0
		ld		b,8
	_lp:
		push	bc

		ld		d,ixh
		inc		ixh
		call	set_vram_adr_de
		ld		hl,tmp_sat-1
		ld		b,0
		inir

		ld		d,ixl
		inc		ixl
		call	set_vram_adr_de
		ld		hl,tmp_sat
		ld		b,0
		otir

		pop		bc
		djnz	_lp
		ret
endp



;==============================================================================
;	文字
;==============================================================================
;JQZは使えない
tx_paled_lb0:	db	18,"COLOR",0,"PALETTE",0,0,"SET"
tx_paled_lb1:	db	18,"PALETTE",0,"SET",0,"ASSIGN"
tx_paled_lb2:	db	6,"STAGE",0
tx_paled_lb3:	db	5,"MSX",0,"A"
tx_paled_lb4:	db	5,"NES",0,"A"
