;===============================================================
;  MSX STAR SOLDIER
;
;	レーザー追加
;
;		laser_stat
;		; b:7) レーザー取得
;		; b:6) 切替キーラッチ
;		; b:5) 装備切替要求
;
;		; b:1) レーザー発射中
;		; b:0) レーザー装備中
;
;===============================================================
laser_spr_ptn	equ	#18
laser_y_vec		equ	#09

laser_bf_fire	equ	1

;===============================
; 発射
;===============================
laser_fire:
val_3a_in_rom_0cdc		equ	#c3
val_ce83_in_rom_0cdd	equ	laser_fire
proc
		ld		hl,laser_stat
		ld		a,(hl)

		; レーザー持ってる？
		rlca
		jr		c,_laser_proc
	_regular_proc:
		ld		a,(#ce83)	; 本来の処理
		jp		#4cdc+3		; 本来の処理へ

	_laser_proc:
		ld		e,a

	;_check_sw_key:
		; 切替キーチェック
		ld		a,6
		call	#0141
		cpl
		ld		d,a
		ld		a,2
		call	#00d8
		or		d
		ld		d,a
		ld		a,4
		call	#00d8
		or		d
		rrca
		jr		nc,_sw_key_is_off
		rlc		e
		jr		c,_end_check_sw_key
		; 装備切替要求セット
		ld		a,(hl)
		xor		#60			; キーラッチON、装備切替要求反転
		ld		(hl),a
		; 全弾消して終了
		res		laser_bf_fire,(hl)
		ld		hl,#cdf3
		ld		de,#cdf3+1
		ld		bc,14
		ld		(hl),0
		ldir
		ret
	_sw_key_is_off:
		res		6,(hl)		; キーラッチOFF
		rlc		e
	_end_check_sw_key:


	;_sw_req:
		; 装備切替要求チェック
		ld		a,e
		and		#21<<2
		jp		pe,_end_sw_req

		;スプライト書き換え
		ld		l,e
		ld		de,#1f60
		call	set_vram_adr_de

		ld		b,#10
		ld		a,laser_spr_ptn
		rlc		l
		jr		c,_lp_wrt_spr
		ld		hl,#6d10
		ld		a,(#ce84)
		cp		2
		jr		c,_wrt_regular_spr
		ld		l,#78
	_wrt_regular_spr:
		ld		b,8
		otir
		ld		b,8
		xor		a
	_lp_wrt_spr:
		out		(c),a
		djnz	_lp_wrt_spr

		; 装備反転
		ld		hl,laser_stat
		ld		a,(hl)
		xor		1
		ld		(hl),a
		ret
	_end_sw_req:

	;_check_laser_enable:
		; レーザー装備?
		ld		a,(hl)
		rrca
		jr		nc,_regular_proc
		; 発射中?
		rrca
		ret		c
		; トリガON?
		ld		a,(#cdf1)
		or		a
		ret		z

		; 発射
		set		laser_bf_fire,(hl)

		; SE
		ld		a,(#ce81)
		or		a
		jr		nz,_skip_se
		ld		a,7
		ld		(#ce89),a
	_skip_se:

		ld		hl,(#cde9)	; l:mx h:my
		ld		c,l
		ld		a,h
		add		a,laser_y_vec
		ld		de,#cdf3+15
		ld		hl,#cdf3+30
		ld		b,15
	_lp:
		ld		(de),a
		ld		(hl),c
		inc		l
		inc		e
		djnz	_lp
		ret
endp
;===============================
; 移動
;===============================
laser_move:
proc
		ld		a,(#cde9)	; mx
		add		a,3
		ld		c,a

		ld		hl,#cdf3
		ld		de,#cdf3+15
		ld		ix,#cdf3+30
		ld		b,15
	_lp:
		ld		a,(de)
		sub		#20
		cp		#b8
		jp		c,_active
		ld		(hl),0
		jr		_next
	_active:
		sub		laser_y_vec-#20
		sub		b
		ld		(de),a
		ld		(hl),1
		ld		(ix+0),c
	_next:
		inc		hl
		inc		e
		inc		ixl
		djnz	_lp

		; 最後尾が消えるまで発射中
		dec		l
		ld		a,(hl)
		or		a
		ret		nz

		; 消す
		ld		hl,laser_stat
		res		laser_bf_fire,(hl)
		ret
endp


;===============================
;	自機周期処理中のスプライト更新
;===============================
laser_update_shipsprite:
val_005c_in_rom_0c78	equ	laser_update_shipsprite
proc
		ld		a,(laser_stat)
		rrca
		jr		nc,_wrt
		ld		c,#60
	_wrt:
		jp		blt_to_vram
endp
