;===============================================================
;  MSX STAR SOLDIER
;
;	基本PCG書き込み
;
;===============================================================


setup_pcg:
		call	setup_pcg_font
		;jp		setup_pcg_bg
;===============================================================
;	背景PCG書き込み
;===============================================================
setup_pcg_bg:
proc
		ld		hl,pcgcol_bg_lzsa
		call	DecompressLZSA_to_d600

		; ウラ面
		ld		a,(#cf28)
		or		a
		ld		ix,setup_pcg_ura
		ld		iyl,bank_pcg_ura
		call	nz,call_bank_pcg_ura

		; 星の色
		ld		hl,#d600+#800+#200
		ld		de,#d601+#800+#200
		ld		bc,#ff
		ld		(hl),#e0
		ldir
		; nesの色
		ld		a,(cfg_map_type)
		or		a
		call	nz,setup_pcg_bg_nes

		; vramへ
		ld		hl,#d600		; PGT用ソース
		ld		de,#8000
		ld		b,12
		call	_lp_wrt
		ld		hl,#d600+#800	; PGT用ソース
		ld		de,#e000
		ld		b,4
	_lp_wrt:
		push	bc
		ld		bc,#800
		push	hl
		call	blt_to_vram
		pop		hl
		ld		a,d
		add		a,8
		ld		d,a
		pop		bc
		djnz	_lp_wrt
		ret
endp



;===============================================================
;	nes用に色を変える
;===============================================================
setup_pcg_bg_nes:
proc
		ld		hl,_sw_color_r2b
		push	hl
		ld		b,+(_sw_color_r2b2-_sw_color_r2b)/2
		ld		de,#6644
		call	_sw_color
		pop		hl
		push	hl
		ld		b,+(_sw_color_r2b2-_sw_color_r2b)/2
		ld		de,#8855
		call	_sw_color
		pop		hl
		ld		b,+(_sw_color_r2b2-_sw_color_r2b)/2
		ld		de,#9977
		call	_sw_color

		ld		hl,_sw_color_r2b2
		ld		b,+(_sw_color_b2g-_sw_color_r2b2)/2
		ld		de,#4499
		call	_sw_color

		ld		hl,_sw_color_b2g
		ld		b,+(_sw_color_g2r-_sw_color_b2g)/2
		ld		de,#4433
		call	_sw_color

		ld		hl,_sw_color_g2r
		ld		b,+(_sw_color_end-_sw_color_g2r)/2
		ld		de,#cc66
	_sw_color:
		push	bc
		ld		b,(hl)
		inc		hl
		push	hl
		ld		l,(hl)
		ld		h,#1c		;#1c*8-2=#d6+8
		add		hl,hl
		add		hl,hl
		dec		h
		add		hl,hl

	_lp:					;26b 111c
		ld		a,(hl)
		sub		d
		and		#0f
		ld		a,(hl)
		jr		nz,_skL
		ld		a,e
	_skL:
		and		#0f
		ld		c,a

		ld		a,(hl)
		or		#0f
		sub		d
		and		#f0
		ld		a,(hl)
		jr		nz,_skH
		ld		a,e
	_skH:
		and		#f0
		or		c
		ld		(hl),a
		inc		l
		djnz	_lp

		pop		hl
		inc		hl
		pop		bc
		djnz	_sw_color
		ret

	; 回数、先頭pcg-no ...
	; 赤→青
	_sw_color_r2b:
		db	8,#02, 16,#68, 16,#78, 16,#86, 16,#96, 48,#aa, 48,#ba
		db	24,#c8, 32,#cc, 64,#d8, 16,#e8, 40,#eb, 16,#f9, 32,#fc
	; 4→9
	_sw_color_r2b2:
		db	16,#a2, 16,#b2
	; 4→3
	_sw_color_b2g:
		db	8,#03, 16,#10, 16,#20, 16,#2e, 16,#3e
	; 12→6
	_sw_color_g2r:
		db	8,#08, 8,#18, 16,#26, 16,#9e, 8,#f8, 8,#fb
	_sw_color_end:
endp




;===============================================================
;	文字PCG書き込み
;===============================================================
setup_pcg_font:
proc
		; 形状
		ld		hl,pcg_font_lzsa
		call	DecompressLZSA_to_d600

		; 文字の色
		ld		hl,#d900
		ld		de,#d901
		ld		bc,#2ff
		ld		(hl),#f0
		ldir

		; メッセージ用シフト文字列
		call	setup_pcg_font_msg

		; vramへ
		ld		de,0
		ld		b,3
	_lp:
		push	bc
		ld		hl,#d600	; PGT用ソース
		ld		bc,#300
		call	blt_to_vram
		ld		a,d
		add		a,#20
		ld		d,a
		ld		bc,#300
		call	blt_to_vram
		pop		bc
		ld		a,d
		sub		#20-8
		ld		d,a
		djnz	_lp
		ret
endp


;===============================================================
;	特定のメッセージ用に4ビットシフトしたものを作る
;===============================================================
setup_pcg_font_msg:
proc
		; ステージ数PCGデータをシフト用のエリアにコピー
		ld		de,#d600 + 45*8
		ld		a,(#cde4)
		cp		10
		push	af
		jr		c,_sk
		; "1"をコピー
		ld		hl,#d788
		ld		c,8
		ldir
		sub		10
	_sk:
		; 面ひと桁をコピー
		add		a,'0'
		add		a,a
		add		a,a
		add		a,a
		ld		l,a
		ld		h,#d7
		ld		c,8
		ldir

		; シフト不要？
		pop		af
		ret		c

		; 3文字シフト
		ld		hl,#d600+'.'*8
		ld		de,-8
		ld		bc,+8*2+1
		ld		ixl,8
		xor		a
	_lp:
		rld
		add		hl,de
		rld
		add		hl,de
		rld
		add		hl,bc
		dec		ixl
		jr		nz,_lp
		ret
endp




;===============================================================
;	色違いブロックのmapパーツ→pcg定義
;===============================================================
val_7d16_in_rom_3cc6	equ	#a3a2
val_7774_in_rom_3cc8	equ	#b3b2
;val_7d16_in_rom_3de6	equ	#a3a2
;val_7774_in_rom_3de8	equ	#b3b2
val_7d16_in_rom_3eb6	equ	#a3a2
val_7774_in_rom_3eb8	equ	#b3b2


;===============================================================
;	星用に空けた分のmapパーツ→pcg定義
;===============================================================
val_40_in_rom_03cce	equ	#30
val_4a_in_rom_03e74	equ	#31
val_51_in_rom_03cd1	equ	#32
val_59_in_rom_03eaf	equ	#33
val_59_in_rom_03eb1	equ	#33
val_5a_in_rom_03e5c	equ	#34
val_5a_in_rom_03e5f	equ	#34
val_5b_in_rom_03cd4	equ	#35
val_5c_in_rom_03e6c	equ	#36
val_5d_in_rom_03e4c	equ	#37
val_5d_in_rom_03e4d	equ	#37
val_5d_in_rom_03e51	equ	#37
val_5d_in_rom_03e59	equ	#37
val_5d_in_rom_03e6d	equ	#37
val_5d_in_rom_03e75	equ	#37
val_5d_in_rom_03e79	equ	#37
val_5d_in_rom_03e7d	equ	#37
val_5e_in_rom_03e50	equ	#38
val_5e_in_rom_03e5e	equ	#38
val_5e_in_rom_03e61	equ	#38
val_5f_in_rom_03e54	equ	#39
val_5f_in_rom_03e65	equ	#39
val_5f_in_rom_03e66	equ	#39

;from array import array
;with open("StarSoldier.rom","rb") as f:
;  d=array("B",f.read()[0x3c96:0x3f0e])
;
;for i,s in enumerate([0x40,0x4a,0x51]+range(0x59,0x60)):
;  for j in ["val_%x_in_rom_0%x\tequ\t#%x"%(s,0x3c96+j,0x30+i) for j,v in enumerate(d) if s==v]:
;    print j
