;===============================
;
;	パレット
;
;===============================
init_palette:
proc
		ld		hl,def_st2pal_tbl
		ld		de,cfg_st2pal_tbl+16
		ld		bc,16
		ldir

		ld		de,cfg_palette_tbl
		ld		ixl,16+1
	_lp:
		ld		hl,def_palette_tbl
		ld		bc,32
		ldir
		dec		ixl
		jr		nz,_lp

		ld		hl,def_palette_tbl2
		ld		ixh,+(def_st2pal_tbl-def_palette_tbl2)/31
	_lp1:
		ld		a,(hl)
		inc		hl
		ld		de,cfg_palette_tbl+32
		add		a,e
		ld		e,a
		ld		ixl,15
	_lp2:
		ldi
		ldi
		ex		de,hl
		ld		bc,#1e
		add		hl,bc
		ex		de,hl
		dec		ixl
		jr		nz,_lp2
		dec		ixh
		jr		nz,_lp1
endp
update_palette:
		call	get_cur_palette_tbl
update_palette_hl:
		ld		a,(#0007)
		ld		c,a
		inc		c
		xor		a
		di
		out		(c),a
		ld		a,#80+16
		out		(c),a
		inc		c
		ld		b,32
		otir
		ei
		ret

get_cur_palette_tbl:
proc
		ld		a,(#cddd)	; ボス戦はパレットセット0
		or		a
		jr		z,_end

		ld		hl,cfg_st2pal_tbl
		ld		a,(cfg_map_type)
		rlca
		rlca
		rlca
		rlca
		add		a,l
		ld		l,a
		ld		a,(#cde4)
		dec		a
		jp		p,_non_zero
		xor		a
	_non_zero:
		add		a,l
		ld		l,a

		ld		a,(#cf21)	; 前半、後半チェック
		ld		b,a
		ld		a,(#cdde)
		cpl
		and		b
		rlca
		ld		a,(hl)
		jr		c,_end
		rrca				; 前半は上位4ビット
		rrca
		rrca
		rrca
	_end:
		and		#f
endp
get_cur_palette_tbl_a:
		or		a
		ld		l,0
		rra
		rr		l
		rra
		rr		l
		rra
		rr		l
		add		a,cfg_palette_tbl>>8
		ld		h,a
		ret

def_palette_tbl:
		db	#00,#0, #15,#1, #61,#2, #34,#5, #15,#1, #27,#3, #41,#2, #27,#6
		db	#61,#2, #62,#3, #71,#6, #64,#6, #11,#4, #64,#1, #27,#6, #77,#7

;		db	#00,#0, #00,#0, #11,#6, #33,#7, #15,#1, #27,#3, #41,#2, #27,#6
;		db	#61,#2, #62,#3, #61,#6, #64,#6, #11,#4, #64,#1, #34,#5, #77,#7

;		db	#00,#0, #00,#0, #11,#6, #33,#7, #17,#1, #27,#3, #51,#1, #27,#6
;		db	#71,#1, #73,#3, #61,#6, #64,#6, #11,#4, #65,#2, #55,#5, #77,#7

def_palette_tbl2:
		db	#6*2, #41,#1, #41,#1, #30,#0, #30,#0, #20,#1, #30,#0, #00,#1, #00,#1, #00,#0, #00,#2, #30,#0, #14,#0, #50,#0, #20,#1, #20,#1
		db	#9*2, #52,#2, #52,#2, #60,#2, #60,#2, #40,#3, #60,#2, #01,#4, #01,#4, #43,#0, #40,#3, #00,#4, #33,#3, #33,#3, #40,#3, #00,#4
		db	#4*2, #20,#4, #11,#4, #60,#1, #50,#0, #55,#0, #33,#3, #47,#0, #07,#3, #00,#5, #72,#0, #55,#0, #04,#4, #04,#4, #47,#0, #00,#5
		db	#5*2, #10,#5, #11,#5, #70,#1, #60,#0, #66,#0, #44,#4, #67,#1, #17,#4, #00,#6, #73,#1, #66,#0, #05,#5, #05,#5, #57,#1, #00,#6
		db	#7*2, #10,#6, #21,#7, #76,#2, #76,#2, #76,#2, #66,#6, #77,#2, #27,#6, #00,#7, #76,#2, #77,#0, #06,#6, #06,#6, #67,#2, #00,#7
		db	#3*2, #73,#3, #73,#3, #34,#5, #34,#5, #71,#4, #71,#4, #34,#5, #07,#3, #34,#5, #07,#3, #07,#3, #34,#5, #34,#5, #07,#3, #14,#0
def_st2pal_tbl:
		db	#12, #12, #34, #34, #56, #56, #78, #78, #19, #19, #ab, #ab, #cd, #cd, #ef, #58


; 敵の色
val_7f_in_rom_50d2	equ	#ef
val_4f_in_rom_5143	equ	#1f
val_4f_in_rom_5171	equ	#1f
val_4f_in_rom_51cf	equ	#1f
val_4f_in_rom_537a	equ	#1f
val_4f_in_rom_53fc	equ	#1f
val_4f_in_rom_5512	equ	#1f
val_8f_in_rom_559b	equ	#2f
val_8f_in_rom_55a5	equ	#2f
val_8f_in_rom_562b	equ	#2f
val_f8_in_rom_5691	equ	#f2
val_8f_in_rom_56ba	equ	#2f
val_8f_in_rom_5702	equ	#2f
val_4f_in_rom_5727	equ	#1f
val_8f_in_rom_5760	equ	#2f
val_7f_in_rom_5780	equ	#ef

val_4f_in_rom_44a7	equ	#1f		; ふらふら
;val_4f_in_rom_4775	equ	#1f

val_f3_in_rom_135c	equ	#fc		; アイテム
