#
# Star Soldier 
#
#	itembox_start	隠しアイテムの場所を表示する
#	itembox_stop	隠しアイテムの場所の表示を停止する
#	overlay_start	地形と自弾の当たり判定の表示
#
namespace eval starsoldier {
	proc bgbox_create {} {;
	    set bw [expr 16*600/256];
	    set bh [expr 16*386/192];
		for {set y 0} {$y<15} {incr y} {;
		  for {set x 0} {$x<20} {incr x} {;
		    osd create rectangle r_{$y}_{$x} -w $bw -h $bh -rgba 0 -borderrgba 0xcccccccc -bordersize 1;
		    osd create text t_{$y}_{$x} -rgb 0xeeeeee;
		  };
		};
	}
	proc bgbox_update {} {;
		set adr 0xcc9d;
		set ox [peek 0xcf17];
		for {set y 0} {$y<14} {incr y} {;
		  for {set x 0} {$x<20} {incr x} {;
			set c [peek $adr];
		    incr adr;
		    if {[expr $c < 0x21 || 0xa8 <= $c || 0x96 == $c]} {;
				set bx [expr 28+($x*16-$ox*8)*584/256];
				set by [expr 48+($y*16-16-16)*384/192];
				osd configure r_{$y}_{$x} -x $bx -y $by ;
				osd configure t_{$y}_{$x} -x $bx -y $by -text $c;
		    } else {;
				osd configure r_{$y}_{$x} -y -24;
				osd configure t_{$y}_{$x} -y -24;
		    };
		  };
		};
	}
	proc bgbox_scan {} {;
		bgbox_update;
		after frame starsoldier::bgbox_scan;
	}
	proc bgbox_start {} {;
		bgbox_create;
		bgbox_scan;
	}


	proc bgshotbox_create {} {;
	    set bw [expr 16*600/256];
	    set bh [expr 16*386/192];
		for {set i 0} {$i<15} {incr i} {;
		  osd create rectangle bs_{$i} -w $bw -h $bh -rgba 0xddffff30;
		};
	}
	proc bgshotbox_update {} {;
		set yadr 0xce02;
		set xadr 0xce11;
		set ox [peek 0xcf17];
		for {set i 0} {$i<15} {incr i} {;
			set y [peek $yadr];
			set x [peek $xadr];
			set y [expr ((($y+8)/16)&15)]
			set x [expr ((($x/8+$x/2)/8)&15)]
			set y [expr 48+($y*16-16-16)*384/192];
			set x [expr 28+($x*16-$ox*8)*584/256];
			osd configure bs_{$i} -x $x -y $y ;
			incr yadr;
			incr xadr;
        };
	}
	proc bgshotbox_scan {} {;
		bgshotbox_update;
		after frame starsoldier::bgshotbox_scan;
	}
	proc bgshotbox_start {} {;
		bgshotbox_create;
		bgshotbox_scan;
	}

	proc overlay_start {} {;
		bgbox_start;
		bgshotbox_start;
	}


	set itembox_stat -2;
	proc itembox_create {} {;
		osd create rectangle itembox_rect -rgba 0 -borderrgba 0x88ccffcc -bordersize 1;
		osd create text      itembox_text -rgb 0xeeeeee;
	}
	proc itembox_update {} {;
		for {set adr 0xcc9d} {$adr<0xcdb5} {incr adr} {;
			set c [peek $adr];
		    if {[expr $c < 0x8 || 0xa8 <= $c && $c <= 0xaf || 0xd8 <= $c ]} {;
				if {$starsoldier::itembox_stat < 16} {set starsoldier::itembox_stat 256};
				if {$starsoldier::itembox_stat > 16} {set starsoldier::itembox_stat [expr $starsoldier::itembox_stat - 8]};
				set bw [expr $starsoldier::itembox_stat *600/256];
				set bh [expr $starsoldier::itembox_stat *386/192];
				set ox [peek 0xcf17];
				set x [expr ($adr-0xcc9d)%20];
				set y [expr ($adr-0xcc9d)/20];
				set bx [expr 28+($x*16-$ox*8+8-$starsoldier::itembox_stat/2)*584/256];
				set by [expr 48+($y*16-16-16+8-$starsoldier::itembox_stat/2)*384/192];
				set tx [expr 28+($x*16-$ox*8)*584/256];
				set ty [expr 48+($y*16-16-16)*384/192];
				osd configure itembox_rect -x $bx -y $by -w $bw -h $bh;
				osd configure itembox_text -x $tx -y $ty -text $c;
				return;
		    };
		};
		osd configure itembox_rect -w 0 -h 0;
		osd configure itembox_text -text "";
		set starsoldier::itembox_stat 0;
	}
	proc itembox_scan {} {;
		if {0 <= $starsoldier::itembox_stat} {;
			itembox_update;
			after frame starsoldier::itembox_scan;
		};
	}
	proc itembox_start {} {;
		if {-2 == $starsoldier::itembox_stat} {itembox_create};
		set starsoldier::itembox_stat 0;
		itembox_scan;
	}
	proc itembox_stop {} {;
		if {-2 == $starsoldier::itembox_stat} {itembox_create};
		set starsoldier::itembox_stat -1;
	}
}

namespace import starsoldier::*
